Bartender3 = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0", "AceDebug-2.0", "AceModuleCore-2.0")

--[[
	Layouts
		0 = simple
		1 = enhanced
		2 = advanced
]]

function Bartender3:OnInitialize()
	self:SetDebugging(true)
	self:RegisterDB("BT3DB")
	
	_, self.playerclass = UnitClass("player")
	
	self:SetupDefaults()
	
	self.unlock = false
	self.bars, self.actionbuttons = {}, {}
	for i=1,120 do
		self.actionbuttons[i] = { state = "unused", object = nil}
	end
	if self.db.profile.Layout == 0 then
		for i=1,10 do
			if self.db.profile.Bars[i].Enabled then
				local bar = Bartender3.Class.ActionBar:new(i, self.db.profile.Bars[i], self.db.profile.Bars[i].Buttons or 12, (i == 1) and true or false)
				self.bars[i] = bar
			end
		end
	else
		-- TODO Advanced
	end
	
	self:RemoveDefaultUIElements()
end

function Bartender3:RemoveDefaultUIElements()
	-- Hide the main grafics
	MainMenuBarArtFrame:Hide()
	MainMenuBarArtFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
	MainMenuBarArtFrame:UnregisterEvent("VARIABLES_LOADED")
	MainMenuBarArtFrame:UnregisterEvent("BAG_UPDATE")
	MainMenuBarArtFrame:UnregisterEvent("ACTIONBAR_PAGE_CHANGED")
	-- Unregister XP Bar Events
	MainMenuExpBar:UnregisterEvent("PLAYER_ENTERING_WORLD")
	MainMenuExpBar:UnregisterEvent("PLAYER_XP_UPDATE")
	ExhaustionTick:UnregisterEvent("PLAYER_ENTERING_WORLD")
	ExhaustionTick:UnregisterEvent("PLAYER_XP_UPDATE")
	ExhaustionTick:UnregisterEvent("UPDATE_EXHAUSTION")
	ExhaustionTick:UnregisterEvent("PLAYER_LEVEL_UP")
	ExhaustionTick:UnregisterEvent("PLAYER_UPDATE_RESTING")

	MainMenuBar:Hide()
	
	-- temp solution to see the missing buttons while coding :)
	TempButtons = {}
	for i=1,10 do table.insert(TempButtons, getglobal("ShapeshiftButton"..i)) end
	for i=1,10 do table.insert(TempButtons, getglobal("PetActionButton"..i)) end
	table.insert(TempButtons, KeyRingButton)
	table.insert(TempButtons, CharacterBag3Slot)
	table.insert(TempButtons, CharacterBag2Slot)
	table.insert(TempButtons, CharacterBag1Slot)
	table.insert(TempButtons, CharacterBag0Slot)
	table.insert(TempButtons, MainMenuBarBackpackButton)
	table.insert(TempButtons, CharacterMicroButton)
	table.insert(TempButtons, SpellbookMicroButton)
	table.insert(TempButtons, TalentMicroButton)
	table.insert(TempButtons, QuestLogMicroButton)
	table.insert(TempButtons, SocialsMicroButton)
	table.insert(TempButtons, LFGMicroButton)
	table.insert(TempButtons, MainMenuMicroButton)
	table.insert(TempButtons, HelpMicroButton)
	for i,v in pairs(TempButtons) do v:SetParent(UIParent) end
	for i,v in pairs(TempButtons) do v:Show() end

end

function Bartender3:OnEnable()
	for i,v in pairs(self.bars) do
		v:RefreshLayout()
	end
end

function Bartender3:OnProfileEnable()
	for i,v in pairs(self.bars) do
		v:UpdateProfile(self.db.profile.Bars[i])
	end
end

function Bartender3:GetFreeButton(bar)
	if self.db.profile.Layout == 0 and bar then
		for i=1,12 do
			local button = ((bar.id-1)*12)+i
			if ( self.actionbuttons[button].state == "unused" ) then 
				local newbutton = Bartender3.Class.Button:new(bar, button)
				self.actionbuttons[button].state = "used"
				self.actionbuttons[button].object = newbutton
				return newbutton
			elseif ( self.actionbuttons[button].state == "free" ) then 
				self.actionbuttons[button].state = "used"
				-- do parent setting and stuff here - TODO - not used in any function yet
				return self.actionbuttons[button].object
			end
		end
	end
end

function Bartender3:Unlock()
	for i,v in pairs(self.bars) do
		if v then v:UnlockFrames() end
	end
	self.unlock = true
end

function Bartender3:Lock()
	for i,v in pairs(self.bars) do
		if v then v:LockFrames() end
	end
	self.unlock = nil
end
